#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;


int main()
{
    int n,q; cin >> n >> q;
    vector<int> a(n);

    for(int i=0; i<n; i++)
        cin >> a[i];

    vector<vector<int>> b(32,vector<int>(n,0));
    for(int i=0; i<n; i++){
        int rr=1, alfa=0;
        while(rr<=a[i]){
            rr*=2;
            alfa++;
        }
        rr/=2;
        alfa--;
        b[alfa][i]=1;
    }

    vector<vector<int>> br(32,vector<int>(n,0));

    int alfa=0;
    while(alfa<32){
        br[alfa][0]=b[alfa][0];
        for(int i=1; i<n; i++)
            br[alfa][i]=br[alfa][i-1]+b[alfa][i];
        alfa++;
    }
    while(q--){
        int l,r; cin >> l >> r;
        l--;r--;
        int maxx=-1;
        for(int alfa=0; alfa<32; alfa++){
            int sad=br[alfa][r];
            if(l>0)sad-=br[alfa][l-1];
            maxx=max(maxx,sad);
        }
        cout << maxx << '\n';
    }
    return 0;
}